﻿Param($username);

# For non-terminating errors force execution to stop and throw an exception
$ErrorActionPreference = "Stop";

$ErrorCode_Success = 0;
$ErrorCode_Failed = 1;

try
{
    $AdminGroupSID = New-Object System.Security.Principal.SecurityIdentifier ("S-1-5-32-544")
    $AdminGroup = $AdminGroupSID.Translate( [System.Security.Principal.NTAccount])
    $AdminGroupName = ([string]$AdminGroup.Value).Split("\")[1];

    Write-Output "Administrators Group Name: $AdminGroupName";

    $index = ([string]$username).IndexOf("\");
    if ($index -ne -1)
    {
        $CurUsername = ([string]$username).Replace("\","/");
        $username = ([string]$username).Split("\")[1];
    }

    $group = [ADSI]"WinNT://$env:COMPUTERNAME/$AdminGroupName,group"
    $members = $Group.psbase.invoke("Members") | %{$_.GetType().InvokeMember("Name", 'GetProperty', $null, $_, $null)}
    if($members -notcontains $username)
    {
        Write-Output "Adding $CurUsername to Administrators group";
        $group.Add("WinNT://$CurUsername");
    }
    else
    {
        Write-Output "$CurUsername is Already added to Administrators group";    
    }

    Exit $ErrorCode_Success;
}
catch
{
   Write-Output "Caught an exception:";
   Write-Output "    Exception Type: $($_.Exception.GetType().FullName)";
   Write-Output "    Exception Message: $($_.Exception.Message)";
   Write-Output "    Exception HResult: $($_.Exception.HResult)";

   Exit $($_.Exception.HResult);
}

