﻿Param($clustername);

$ErrorActionPreference = "Stop";

$ErrorCode_Success = 0;
$ErrorCode_Failed = 1;

try
{
    Write-Output "================";
    Write-Output "Deleting cluster";
    Write-Output "================";

    # Get cluster using its name 
    $cluster = Get-Cluster -Name $clustername -ErrorAction Ignore;
    if (!$cluster)
    { 
        Write-Output "Cluster $clustername is no longer available";
        Exit $ErrorCode_Success;
    }

    Write-Output "Deleting cluster"
    Remove-Cluster -Cluster $cluster -CleanupAD -Force

    Exit $ErrorCode_Success;
}
catch
{
   Write-Output "Caught an exception:";
   Write-Output "    Exception Type: $($_.Exception.GetType().FullName)";
   Write-Output "    Exception Message: $($_.Exception.Message)";
   Write-Output "    Exception HResult: $($_.Exception.HResult)";   

   Exit $($_.Exception.HResult);
}


